﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UsingBaseMapXr
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        //private double[] Scales = null;
        private List<double> Scales = new List<double>();

        private void Form1_Load(object sender, EventArgs e)
        {
            /*
            axXr1.Layers.AddTileMapLayer("basemap", "XrTileMap://www.geoservice.co.kr/map");
            axXr1.WaitForAllConnections();

            double[] scales = { 2048000, 1024000, 512000, 256000, 128000, 64000, 32000, 16000, 8000, 4000, 2000, 1000 };
            Scales.AddRange(scales);

            XrMapLib.TileMapLayer baseLyr = axXr1.Layers.GetLayerAsTileMap("basemap");

            axXr1.MapExtent = baseLyr.MBR;
            axXr1.MapScale = Scales[0];
            axXr1.Update();

            axXr1.MouseMode = XrMapLib.XrMapViewModeEnum.XrPanMode;
            //*/


            //*
            XrMapLib.ValueList URLs = new XrMapLib.ValueList();
            URLs.AddValueByString("http://xdworld.vworld.kr:8080/2d/Base/201512/${z}/${x}/${y}.png"); //201301

            XrMapLib.Extent MaxMBR = new XrMapLib.Extent();
            MaxMBR.MinX = -20037508.342789244;
            MaxMBR.MinY = -20037508.342789244;
            MaxMBR.MaxX = 20037508.342789244;
            MaxMBR.MaxY = 20037508.342789244;

            double[] upps = {
                78000, 39000, 19600, 9800, 4900, 2400, //Dummy
		        1222.9924523925781, 611.4962261962891, 305.74811309814453, 152.87405654907226, 76.43702827453613, 
		        38.218514137268066, 19.109257068634033, 9.554628534317017,
		        4.777314267158508, 2.388657133579254, 1.194328566789627, 0.5971642833948135 };

            XrMapLib.ValueList UPPs = new XrMapLib.ValueList();
            for (int iUPP = 0; iUPP < upps.Length; ++iUPP)
            {
                double UPP = upps[iUPP];
                double MapScale = axXr1.GetMapScaleFromUPP(UPP);

                UPPs.AddValueByFloat(UPP, 14);

                if (iUPP > 5)
                {
                    Scales.Add(MapScale);
                }
                
                //MessageBox.Show(UPP + " " + MapScale);
            }

            axXr1.Layers.AddTMSLayer("basemap", URLs, MaxMBR, UPPs, true);
            axXr1.WaitForAllConnections();

            XrMapLib.Coord MapCenter = new XrMapLib.Coord();
            MapCenter.X = 14289580.202989;
            MapCenter.Y = 4436964.90266281;
            axXr1.MapCenter = MapCenter;
            axXr1.MapScale = Scales[0];
            axXr1.Update();

            axXr1.MouseMode = XrMapLib.XrMapViewModeEnum.XrPanMode;

            //if(axXr1.Layers.GetLayerType("basemap") == XrMapLib.XrLayerTypeEnum.XrTileMapLayerType)
            //{
            //    XrMapLib.TileMapLayer lyr = axXr1.Layers.GetLayerAsTileMap("basemap");
            //    MessageBox.Show(lyr.MBR.MaxX.ToString());
            //}
            //*/
        }

        private void btnPan_Click(object sender, EventArgs e)
        {
            axXr1.MouseMode = XrMapLib.XrMapViewModeEnum.XrPanMode;
        }

        private void btnZoomIn_Click(object sender, EventArgs e)
        {
            axXr1.MouseMode = XrMapLib.XrMapViewModeEnum.XrZoomInMode;
        }

        private void btnZoomOut_Click(object sender, EventArgs e)
        {
            axXr1.MouseMode = XrMapLib.XrMapViewModeEnum.XrZoomOutMode;
        }

        private void axXr1_OnBeforeMapDrawing(object sender, EventArgs e)
        {
            double NewMapScale = axXr1.MapScale;

            int cntLevels = Scales.Count;
            double Gap = Double.MaxValue;
            int CurrentLevel = -1;
            for (int i = 0; i < cntLevels; i++)
            {
                double ThatGap = Math.Abs(NewMapScale - Scales[i]);
                if (Gap > ThatGap)
                {
                    Gap = ThatGap;
                    CurrentLevel = i;
                }
            }

            axXr1.MapScale = Scales[CurrentLevel];
        }
    }
}
